CREATE OR REPLACE PROCEDURE IFIX_GRANTS
(
 p_procedurename IN VARCHAR2
,p_schemaname	IN VARCHAR2
,p_dbusername   IN VARCHAR2
)
AS

v_flag INTEGER DEFAULT '0';
v_sql_grant VARCHAR2(200);
v_sql_syn VARCHAR2(200);
v_procedurename VARCHAR(50);

BEGIN

	BEGIN

		v_procedurename := UPPER(LTRIM(TRIM(p_procedurename)));
	
		dbms_output.put_line ( v_procedurename );

		SELECT COUNT(*) INTO v_flag from user_procedures
		where object_name = v_procedurename;

		EXCEPTION

			WHEN NO_DATA_FOUND THEN
			v_flag := 0 ;
			dbms_output.put_line ( ' No Need to Execute Grant on passed procedurename ' );
	
			WHEN OTHERS THEN
			RAISE_APPLICATION_ERROR (-20999,'20002 IFIX_GRANTS' || SQLCODE|| ' '||SQLERRM);

	END;

	IF v_flag <> 0 THEN

		dbms_output.put_line (' Granting Permission ');
	
		-- Execute privilege for procedure

		v_sql_grant := 'GRANT EXECUTE ON ' || p_procedurename || ' TO ' || p_dbusername ;

		dbms_output.put_line ( 'v_sql_grant = ' || v_sql_grant );

		EXECUTE IMMEDIATE(v_sql_grant);
	
		-- Create synonym for passed procedure
	
		v_sql_syn := 'create or replace synonym ' || p_dbusername || '.' || p_procedurename || 
		' FOR ' || p_schemaname || '.' || p_procedurename ;
			
		dbms_output.put_line ( 	'v_sql_syn' || v_sql_syn );
	
		EXECUTE IMMEDIATE (v_sql_syn);

	END IF;

	EXCEPTION

		WHEN OTHERS THEN
		RAISE_APPLICATION_ERROR (-20999,'20002 IFIX_GRANTS' || SQLCODE|| ' '||SQLERRM);

	END IFIX_GRANTS;
/




CALL IFIX_GRANTS('PR_ALERTS_AH2','$Schema_Name$','$WPGDBUser$')
/